using UnityEngine;
using UnityEngine.UI;
using System.Linq;
using System.Collections;
using System.Collections.Generic;

namespace gmarth
{
  public class OffControllerNotTargetable : MVRScript
  {

    float lastUpdateTime;
    List<FreeControllerV3> controllersOff = new List<FreeControllerV3>();
    // That or a lot of object finding and fiddling around...
    string[] personControls = new string[] {
      "hipControl",
      "pelvisControl",
      "chestControl",
      "headControl",
      "rHandControl",
      "lHandControl",
      "rFootControl",
      "lFootControl",
      "neckControl",
      "rNippleControl",
      "lNippleControl",
      "testesControl",
      "penisBaseControl",
      "penisMidControl",
      "penisTipControl",
      "rElbowControl",
      "lElbowControl",
      "rKneeControl",
      "lKneeControl",
      "rToeControl",
      "lToeControl",
      "abdomenControl",
      "abdomen2Control",
      "rThighControl",
      "lThighControl",
      "rArmControl",
      "lArmControl",
      "rShoulderControl",
      "lShoulderControl"};
    Dictionary<string, string> personControlerLinks = new Dictionary<string, string>(){
      {"hipControl", "hipLink"},
      {"pelvisControl", "pelvisLink"},
      {"chestControl", "chestLink"},
      {"headControl", "headLink"},
      {"rHandControl", "rHandLink"},
      {"lHandControl", "lHandLink"},
      {"rFootControl", "rFootLink"},
      {"lFootControl", "lFootLink"},
      {"rElbowControl", "rElbowLink"},
      {"lElbowControl", "lElbowLink"},
      {"rKneeControl", "rKneeLink"},
      {"lKneeControl", "lKneeLink"},
      {"abdomenControl", "abdomenLink"},
      {"abdomen2Control", "abdomen2Link"}};

    public override void Init(){
      base.Init();
      lastUpdateTime = Time.time;
    }

    void Update()
    {
      // Only update every second. Know a better way? please let me know :)
      if(Time.time > lastUpdateTime + 1)
      {
        lastUpdateTime = Time.time;
        UpdateSphereColliders();
      }
    }

    public void UpdateSphereColliders(bool forceEnabled = false)
    {
      List<Atom> atoms = SuperController.singleton.GetAtoms();
      foreach(Atom atom in atoms){
        // Only process People atoms
        if(atom.category == "People")
        {
          // Iterate over known Controller Array
          foreach(string controllerID in personControls)
          {
            FreeControllerV3 controller = atom.GetStorableByID(controllerID) as FreeControllerV3;
            FreeControllerV3Link controllerLink = null;
            //SuperController.LogMessage($"Controller: {controller.gameObject.name}");
            //Get the Link if there is one
            if(personControlerLinks.ContainsKey(controllerID))
            {
              controllerLink = controller.gameObject.transform.parent.Find(personControlerLinks[controllerID]).GetComponent<FreeControllerV3Link>() as FreeControllerV3Link;
              //SuperController.LogMessage($"And his Link: {controllerLink.gameObject.name}");
            }
            if(!forceEnabled && UserPreferences.singleton.hideInactiveTargets
              && SuperController.singleton.gameMode == SuperController.GameMode.Edit
              && controller.currentPositionState == FreeControllerV3.PositionState.Off
              && controller.currentRotationState == FreeControllerV3.RotationState.Off)
            {
              controller.gameObject.GetComponent<SphereCollider>().enabled = false;
              if(controllerLink)
                controllerLink.gameObject.GetComponent<SphereCollider>().enabled = false;
            } else {
                controller.gameObject.GetComponent<SphereCollider>().enabled = true;
                if(controllerLink)
                  controllerLink.gameObject.GetComponent<SphereCollider>().enabled = true;
            }
          }
        }
      }
    }

    void OnDisable()
    {
      UpdateSphereColliders(true);
    }
  }
}
